unit Unit1;

interface

uses
    Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
    Dialogs, StdCtrls, ExtCtrls;

type
    TForm1 = class(TForm)
        Memo1: TMemo;
        Panel1: TPanel;
        Button1: TButton;
        procedure FormCreate(Sender: TObject);
        procedure FormDestroy(Sender: TObject);
        procedure Button1Click(Sender: TObject);
    private

    public

    end;

var
    Form1: TForm1;

implementation

uses
    WinSock;

{$R *.dfm}

// Winsockgp
function	tzWSAStartup(): integer;
var
    ad: TWSAData;
begin
    Result := WSAStartup($0101, ad);
end;

// Winsockgp
function	tzCloseSocket(): integer;
begin
    Result := WSACleanup();
end;

// IPAhXzXgIPAhXłԂ
// http://www.asahi-net.or.jp/~nk2w-ishr/winsock3.htm
function	GetInetAddr(AHostStr: string): integer;
var
    ip	: u_long;
    phe	: PHostEnt;
begin

    // 10i\L?
    ip := inet_addr(PChar(AHostStr));

    // Ⴄ
    if ip = INADDR_NONE then
    begin
        phe := gethostbyname(PChar(AHostStr))
    end else
    // 
    begin
        phe := gethostbyaddr(@ip, 4, AF_INET);
    end;

    // ߂
    if not assigned(phe) then raise Exception.Create('gethostby**** error');

    // Ƃ
    Result := inet_addr(inet_ntoa(PInAddr(phe^.h_addr_list^)^));

end;

// RXgN^
procedure TForm1.FormCreate(Sender: TObject);
begin
    tzWSAStartup();
end;

// fXgN^
procedure TForm1.FormDestroy(Sender: TObject);
begin
    tzCloseSocket();
end;

// C/C++300̋Z(P37)
// http://www.asahi-net.or.jp/~nk2w-ishr/winsock9.htm
procedure TForm1.Button1Click(Sender: TObject);
var
    sock, csock: TSocket;
    sockaddr, csockaddr: TSockAddr;
    caddrlen: integer;
    html: string;
    recvdata: array[0..1024] of Char;
    recvlen, sendlen: integer;

    limitcount: integer;
begin

    limitcount := 0;

    try

        // @ԂHTMLR[h
        html := '<html><head>WebServer</head><body>here i am !!</body></html>';

        // \Pbg쐬
        sock := socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);

        // ꂽH
        if sock = INVALID_SOCKET then
        begin
            raise Exception.Create('socket error');
        end;

        // AhXE|[gw
        FillChar(sockaddr, SizeOf(TSockAddr), #0);
        sockaddr.sin_family      := AF_INET;
        sockaddr.sin_port        := htons(80);
        sockaddr.sin_addr.S_addr := INADDR_ANY;

        // |[gԍƂ̃vZXoCh
        if bind(sock, sockaddr, sizeof(sockaddr)) = SOCKET_ERROR then
        begin
            closesocket(sock);
            raise Exception.Create('bind error');
        end;

        // [h
        if listen(sock, SOMAXCONN) = SOCKET_ERROR then
        begin
            closesocket(sock);
            raise Exception.Create('listen error');
        end;

        // ۂ͌̂悤ɑ҂Â邪...
//        while True do
        while limitcount < 5 do
        begin

            // ڑ҂
            caddrlen := SizeOf(csockaddr);
            FillChar(csockaddr, SizeOf(TSockAddr), #0);
            csock := accept(sock, @csockaddr, @caddrlen);
            if csock = INVALID_SOCKET then
            begin
                closesocket(sock);
                raise Exception.Create('accept error');
            end;

            // 
            FillChar(recvdata, SizeOf(recvdata), #0);

            // [(ŏ\Eǂ͂ȂĂ͂邩)
            recvlen := recv(csock, recvdata, Length(recvdata), 0);

            // G[ȂI
            if recvlen = SOCKET_ERROR then
            begin
                closesocket(sock);
                closesocket(csock);
                raise Exception.Create('recv error');
            end;

            // mꉞĂ݂悤
            Memo1.Lines.Add(StringOfChar('-', 50));
            Memo1.Lines.Add(recvdata);

            // s[
            sendlen := send(csock, html[1], length(html), 0);

            // G[ȂI
            if sendlen = SOCKET_ERROR then
            begin
                closesocket(sock);
                closesocket(csock);
                raise Exception.Create('send error');
            end;

            // mꉞĂ݂悤
            Memo1.Lines.Add(html);

            // \Pbgp
            closesocket(csock);

            // Xbhł˂̂ɒ߂B
            Inc(limitcount);

        end;

        // \Pbgp
        closesocket(sock);

    except

        on E:Exception do
        begin
            Memo1.Lines.Add(E.Message);
        end;

    end;

end;

end.
